# This file is part of Grow-bots.
#
# Grow-bots is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Grow-bots is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Grow-bots.  If not, see <http://www.gnu.org/licenses/>.

"""
Nothing fancy here, just passing some messages around
"""

class Events:

    def __init__(self):
        self.events = {}

    def register(self, event_type):
        if not event_type in self.events:
            self.events[event_type] = []

    def add(self, event_type, event_func):
        if event_type in self.events:
            self.events[event_type].append(event_func)
        else:
            self.events[event_type] = [event_func]

    def remove(self, event_type, event_func):
        self.events[event_type].remove(event_func)

    def send(self, event_type, event_data=None):
        if event_type in self.events:
            for event in self.events[event_type]:
                try:
                    event(event_data)
                except TypeError:
                    event()

