# This file is part of Grow-bots.
#
# Grow-bots is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Grow-bots is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Grow-bots.  If not, see <http://www.gnu.org/licenses/>.

import dyna

"""
Manages mouse events
(turn out, I didn't even need this...)
"""

class Mouse:

    def __init__(self, events):
        self.button = {}
        self.x, self.y = 0, 0
        self.parent = events
        self.events = dyna.Events()
        events.add("buttondown", self.set_down)
        events.add("buttonup", self.set_up)
        events.add("mousemotion", self.set_motion)

    def set_down(self, data):
        self.button[data] = True

    def set_up(self, data):
        self.button[data] = False

    def set_motion(self, data):
        self.x, self.y = data

    def is_down(self, button):
        if button in self.button:
            return self.button[button]
        else:
            return False

    def on_down(self, button):
        if button in self.button:
            state = self.key[button]
            self.button[button] = False
            return state
        else:
            return False

